Index: issm/trunk/src/jl/core/solutionsequences.jl
===================================================================
--- issm/trunk/src/jl/core/solutionsequences.jl	(revision 26744)
+++ issm/trunk/src/jl/core/solutionsequences.jl	(revision 26744)
@@ -0,0 +1,132 @@
+function solutionsequence_linear(femmodel::FemModel,analysis::Analysis) # {{{
+
+	#First, update constraints in case the levelset has changed
+	UpdateConstraintsx(femmodel, analysis)
+
+	#Get new matrices
+	Kff, Kfs, pf = SystemMatricesx(femmodel,analysis)
+
+	#Enforce constraints
+	ys = CreateNodalConstraintsx(femmodel.nodes)
+	Reduceloadx!(pf, Kfs, ys)
+
+	#Solve!
+	uf = Solverx(Kff, pf)
+
+	#Merge uf with ys and update inputs
+	gsize = NumberOfDofs(femmodel.nodes,GsetEnum)
+	ug = IssmVector(gsize)
+	Mergesolutionfromftogx(ug, uf, ys, femmodel.nodes)
+
+	InputUpdateFromSolutionx(analysis, ug, femmodel)
+
+end# }}}
+function solutionsequence_nonlinear(femmodel::FemModel,analysis::Analysis,maxiter::Int64,restol::Float64,reltol::Float64,abstol::Float64) # {{{
+
+	#First, update constraints in case the levelset has changed
+	UpdateConstraintsx(femmodel, analysis)
+
+	#Initialize number of iterations
+	count = 0
+	converged = false
+
+	#Get existing solution
+	ug = GetSolutionFromInputsx(analysis,femmodel)
+	uf = Reducevectorgtofx(ug,femmodel.nodes)
+
+	#Update once again the solution to make sure that vx and vxold are similar (for next step in transient or steadystate)
+	InputUpdateFromSolutionx(analysis,ug,femmodel)
+
+	#Loop until we reach convergence
+	while(~converged)
+
+		#Get new matrices
+		Kff, Kfs, pf = SystemMatricesx(femmodel,analysis)
+
+		#Enforce constraints
+		ys = CreateNodalConstraintsx(femmodel.nodes)
+		Reduceloadx!(pf, Kfs, ys)
+
+		#Solve!
+		old_uf = uf
+		uf = Solverx(Kff, pf, old_uf)
+
+		#Merge uf with ys
+		Mergesolutionfromftogx(ug, uf, ys, femmodel.nodes)
+
+		#Check for convergence
+		converged = convergence(Kff,pf,uf,old_uf,restol,reltol,abstol)
+		InputUpdateFromSolutionx(analysis,ug,femmodel)
+
+		#Increase count
+		count += 1
+		if(count>=maxiter)
+			println("   maximum number of nonlinear iterations (",maxiter,") exceeded")
+			converged = true
+		end
+	end
+
+	print("\n   total number of iterations: ",  count,  "\n")
+
+end# }}}
+function convergence(Kff::IssmMatrix, pf::IssmVector, uf::IssmVector, old_uf::IssmVector, restol::Float64, reltol::Float64, abstol::Float64)#{{{
+
+	print("   checking convergence\n");
+
+	#If solution vector is empty, return true
+	if(IsEmpty(uf))
+		return true
+	end
+
+	#Convergence criterion #1: force equilibrium (Mandatory)
+	#compute K[n]U[n-1] - F
+	KUold  = Duplicate(uf);    MatMult!(Kff,old_uf,KUold)
+	KUoldF = Duplicate(KUold); VecCopy!(KUold, KUoldF); AXPY!(KUoldF, -1.0, pf)
+	nKUoldF = Norm(KUoldF,2)
+	nF      = Norm(pf,2)
+	res = nKUoldF/nF
+	if ~isfinite(res)
+		println("norm nf = ", nF, " and norm kuold = ",nKUoldF)
+		error("mechanical equilibrium convergence criterion is not finite!")
+	end
+	if(res<restol)
+		print("   mechanical equilibrium convergence criterion ", res*100, " < ", restol*100, " %\n")
+		converged=true
+	else
+		print("   mechanical equilibrium convergence criterion ", res*100, " > ", restol*100, " %\n")
+		converged=false;
+	end
+
+	#Convergence criterion #2: norm(du)/norm(u)
+	if ~isnan(reltol)
+		duf = Duplicate(old_uf); VecCopy!(old_uf,duf); AXPY!(duf, -1.0, uf)
+		ndu = Norm(duf, 2); nu = Norm(old_uf, 2)
+		if ~isfinite(ndu) | ~isfinite(nu) 
+			error("convergence criterion is not finite!")
+		end
+		if((ndu/nu)<reltol)
+			print("   Convergence criterion: norm(du)/norm(u)      ", ndu/nu*100, " < ", reltol*100, " %\n")
+		else
+			print("   Convergence criterion: norm(du)/norm(u)      ", ndu/nu*100, " > ", reltol*100, " %\n")
+			converged=false;
+		end
+	end
+
+	#Convergence criterion #3: max(du)
+	if ~isnan(abstol)
+		duf = Duplicate(old_uf); VecCopy!(old_uf,duf); AXPY!(duf, -1.0, uf)
+		nduinf= Norm(duf, 3)
+		if ~isfinite(nduinf) 
+			error("convergence criterion is not finite!")
+		end
+		if(nduinf<abstol)
+			print("   Convergence criterion: max(du)               ", nduinf, " < ", abstol, "\n")
+		else
+			print("   Convergence criterion: max(du)               ", nduinf, " > ", abstol, "\n")
+			converged=false;
+		end
+	end
+
+	return converged
+
+end#}}}
Index: issm/trunk/src/jl/core/solve.jl
===================================================================
--- issm/trunk/src/jl/core/solve.jl	(revision 26744)
+++ issm/trunk/src/jl/core/solve.jl	(revision 26744)
@@ -0,0 +1,45 @@
+include("../usr/classes.jl")
+include("./issmenums.jl")
+include("./toolkits.jl")
+include("./gauss.jl")
+include("./parameters.jl")
+include("./inputs.jl")
+include("./vertices.jl")
+include("./nodes.jl")
+include("./elements.jl")
+include("./constraints.jl")
+include("./results.jl")
+include("./matice.jl")
+include("./friction.jl")
+include("./analyses/analysis.jl")
+include("./femmodel.jl")
+
+#All analyses
+include("./analyses/stressbalanceanalysis.jl")
+include("./analyses/masstransportanalysis.jl")
+include("./analyses/transientanalysis.jl")
+
+include("./solutionsequences.jl")
+include("./modules.jl")
+include("./elementmatrix.jl")
+include("./utils.jl")
+
+function IssmCore(md::model, solutionstring::String) #{{{
+
+	#Construct FemModel
+	femmodel=ModelProcessor(md, solutionstring)
+
+	#Solve FIXME: to be improved later...
+	if(solutionstring=="StressbalanceSolution")
+		analysis = StressbalanceAnalysis()
+	elseif (solutionstring=="TransientSolution")
+		analysis = TransientAnalysis()
+	else
+		error("not supported")
+	end
+	Core(analysis, femmodel)
+
+	#move results to md
+	OutputResultsx(femmodel, md, solutionstring)
+
+end# }}}
Index: issm/trunk/src/jl/core/toolkits.jl
===================================================================
--- issm/trunk/src/jl/core/toolkits.jl	(revision 26744)
+++ issm/trunk/src/jl/core/toolkits.jl	(revision 26744)
@@ -0,0 +1,150 @@
+
+#Toolkit #1: serial sparse arrays
+using SparseArrays
+
+#Matrix
+mutable struct IssmMatrix #{{{
+	M::Int64
+	N::Int64
+	rows::Vector{Int64}
+	cols::Vector{Int64}
+	vals::Vector{Float64}
+	matrix::SparseMatrixCSC{Float64,Int64}
+end #}}}
+function IssmMatrix(M::Int64,N::Int64)#{{{
+	return IssmMatrix(M, N, Vector{Int64}(undef,0), Vector{Int64}(undef,0), Vector{Float64}(undef,0), spzeros(0,0))
+end#}}}
+function AddValues!(matrix::IssmMatrix,m::Int64,midx::Vector{Int64},n::Int64,nidx::Vector{Int64},values::Matrix{Float64})#{{{
+
+	#This is inefficient now, but it will work
+	for i in 1:m
+		if(midx[i]==-1) continue end
+		for j in 1:n
+			if(nidx[j]==-1) continue end
+			push!(matrix.rows, midx[i])
+			push!(matrix.cols, nidx[j])
+			push!(matrix.vals, values[i,j])
+		end
+	end
+
+end#}}}
+function GetSize(matrix::IssmMatrix)#{{{
+
+	return size(matrix.matrix)
+
+end#}}}
+function Assemble!(matrix::IssmMatrix)#{{{
+
+	matrix.matrix = sparse(matrix.rows, matrix.cols, matrix.vals, matrix.M, matrix.N)
+
+end#}}}
+
+#Vector
+mutable struct IssmVector #{{{
+	vector::Vector{Float64}
+end #}}}
+function IssmVector(M::Int64)#{{{
+	return IssmVector(zeros(M))
+end#}}}
+function GetSize(vector::IssmVector)#{{{
+
+	return length(vector.vector)
+
+end#}}}
+function AddValues!(vector::IssmVector,m::Int64,midx::Vector{Int64},values::Vector{Float64})#{{{
+
+	#This is inefficient now, but it will work
+	for i in 1:m
+		if(midx[i]==-1) continue end
+		vector.vector[midx[i]] += values[i]
+	end
+
+end#}}}
+function SetValues!(vector::IssmVector,m::Int64,midx::Vector{Int64},values::Vector{Float64})#{{{
+
+	#This is inefficient now, but it will work
+	for i in 1:m
+		if(midx[i]==-1) continue end
+		vector.vector[midx[i]] = values[i]
+	end
+
+end#}}}
+function IsEmpty(vector::IssmVector)#{{{
+
+	return GetSize(vector)==0
+
+end#}}}
+function Duplicate(vector::IssmVector)#{{{
+
+	#Copy data structure
+	M=GetSize(vector)
+	return IssmVector(M)
+
+end#}}}
+function VecCopy!(x::IssmVector,y::IssmVector)#{{{
+
+	y.vector = x.vector
+
+end#}}}
+function Assemble!(vector::IssmVector)#{{{
+
+	#Nothing to do for this toolkit
+
+end#}}}
+function ToSerial(vector::IssmVector)#{{{
+
+	return vector.vector
+
+end#}}}
+function Norm(x::IssmVector,type::Int64)#{{{
+
+	norm = 0
+
+	if type==2
+		for i in 1:length(x.vector)
+			norm += x.vector[i]^2
+		end
+		norm = sqrt(norm)
+	elseif type==3
+		#Infinite norm
+		for i in 1:length(x.vector)
+			if(abs(x.vector[i])>norm) norm = abs(x.vector[i]) end
+		end
+	else
+		error("type ",type," not supported yet")
+	end
+
+	return norm
+
+end#}}}
+
+#Operations
+function MatMult!(A::IssmMatrix,x::IssmVector,y::IssmVector) #{{{
+
+	y.vector = A.matrix*x.vector
+
+end#}}}
+function AXPY!(y::IssmVector,alpha::Float64,x::IssmVector) #{{{
+
+	y.vector = alpha*x.vector + y.vector
+
+end#}}}
+function Solverx(A::IssmMatrix, b::IssmVector, xold::IssmVector) #{{{
+
+	#Initialize output
+	#x = IssmVector(GetSize(xold))
+	
+	return Solverx(A, b)
+
+end#}}}
+function Solverx(A::IssmMatrix, b::IssmVector) #{{{
+
+	#Initialize output
+	x = IssmVector(0)
+
+	#Solve linear system
+	x.vector = A.matrix\b.vector
+
+	return x
+
+end#}}}
Index: issm/trunk/src/jl/core/utils.jl
===================================================================
--- issm/trunk/src/jl/core/utils.jl	(revision 26744)
+++ issm/trunk/src/jl/core/utils.jl	(revision 26744)
@@ -0,0 +1,26 @@
+function Matrix2x2Determinant(A::Matrix{Float64}) #{{{
+
+	return  A[1,1]*A[2,2]-A[2,1]*A[1,2]
+
+end#}}}
+function Matrix2x2Invert(A::Matrix{Float64}) #{{{
+
+	#Initialize output
+	Ainv = Matrix{Float64}(undef,2,2)
+
+	#Compute determinant
+	det = Matrix2x2Determinant(A)
+	if(abs(det)<eps(Float64)) error("Determinant smaller than machine epsilon") end
+
+	#Multiplication is faster than divsion, so we multiply by the reciprocal
+	det_reciprocal = 1/det
+
+	#compute invert matrix
+	Ainv[1,1]=   A[2,2]*det_reciprocal # =  d/det
+   Ainv[1,2]= - A[1,2]*det_reciprocal # = -b/det
+   Ainv[2,1]= - A[2,1]*det_reciprocal # = -c/det
+   Ainv[2,2]=   A[1,1]*det_reciprocal # =  a/det
+
+	return  Ainv
+
+end#}}}
Index: issm/trunk/src/jl/core/vertices.jl
===================================================================
--- issm/trunk/src/jl/core/vertices.jl	(revision 26744)
+++ issm/trunk/src/jl/core/vertices.jl	(revision 26744)
@@ -0,0 +1,26 @@
+#Vertex class definition
+mutable struct Vertex#{{{
+	sid::Int64
+	x::Float64
+	y::Float64
+	z::Float64
+end# }}}
+
+#vertices functions
+function GetVerticesCoordinates(vertices::Vector{Vertex}) #{{{
+
+	#Intermediaries
+	nbv = length(vertices)
+
+	#Allocate
+	xyz_list = Matrix{Float64}(undef,nbv,3)
+
+	#Assign value to xyz_list
+	for i in 1:nbv
+		xyz_list[i,1]=vertices[i].x
+		xyz_list[i,2]=vertices[i].y
+		xyz_list[i,3]=vertices[i].z
+	end
+
+	return xyz_list
+end #}}}
Index: issm/trunk/src/jl/issm.jl
===================================================================
--- issm/trunk/src/jl/issm.jl	(revision 26744)
+++ issm/trunk/src/jl/issm.jl	(revision 26744)
@@ -0,0 +1,20 @@
+# Julia version of the Ice-sheet and Sea-level System Model
+#
+# Author: Mathieu Morlighem
+# email:  mathieu.morlighem@dartmouth.edu
+
+module ISSM
+
+include("usr/classes.jl")
+export model
+include("usr/exp.jl")
+export expread, ContourToNodes
+include("usr/utils.jl")
+export archread, solve, issmdir
+include("usr/triangle.jl")
+export triangle
+include("usr/parameterization.jl")
+export setmask, InterpFromMeshToMesh2d
+include("core/solve.jl")
+
+end
Index: issm/trunk/src/jl/tests/test.jl
===================================================================
--- issm/trunk/src/jl/tests/test.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test.jl	(revision 26744)
@@ -0,0 +1,14 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+using MAT
+
+#Load model from MATLAB file
+#file = matopen("./Pig.mat")
+file = matopen("/Users/mmorligh/Desktop/issmuci/trunk-jpl/test/NightlyRun/temp.mat")
+mat  = read(file, "md")
+close(file)
+md = model(mat)
+
+#Solve stress balance
+md = solve(md, "Stressbalance")
Index: issm/trunk/src/jl/tests/test101.jl
===================================================================
--- issm/trunk/src/jl/tests/test101.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test101.jl	(revision 26744)
@@ -0,0 +1,45 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+
+md = model()
+md = triangle(md,issmdir()*"/test/Exp/Square.exp",50000.)
+md = setmask(md,"all","")
+
+#Geometry
+hmin=300.
+hmax=1000.
+ymin=minimum(md.mesh.y)
+ymax=maximum(md.mesh.y)
+xmin=minimum(md.mesh.x)
+xmax=maximum(md.mesh.x)
+md.geometry.thickness = hmax .+ (hmin-hmax)*(md.mesh.y .- ymin)./(ymax-ymin) .+ 0.1*(hmin-hmax)*(md.mesh.x .- xmin)./(xmax-xmin)
+md.geometry.base      = -md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness
+md.geometry.surface   = md.geometry.base+md.geometry.thickness
+md.geometry.bed       = md.geometry.base .-10
+
+#Initial velocity
+x     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","x")
+y     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","y")
+vx    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vx")
+vy    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vy")
+index = Int.(archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","index"))
+md.initialization.vx=0 .*InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y,0.0)
+md.initialization.vy=0 .*InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y,0.0)
+
+md.materials.rheology_B=1.815730284801701e+08*ones(md.mesh.numberofvertices)
+md.materials.rheology_n=3*ones(md.mesh.numberofelements)
+md.friction.coefficient=20*ones(md.mesh.numberofvertices)
+
+md.stressbalance.restol=0.05
+md.stressbalance.reltol=0.05
+md.stressbalance.abstol=NaN
+
+#Boundary conditions
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices)
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices)
+pos = findall(md.mesh.vertexonboundary)
+md.stressbalance.spcvx[pos] .= 0.0
+md.stressbalance.spcvy[pos] .= 0.0
+
+md=solve(md,"Stressbalance")
Index: issm/trunk/src/jl/tests/test201.jl
===================================================================
--- issm/trunk/src/jl/tests/test201.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test201.jl	(revision 26744)
@@ -0,0 +1,51 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+
+md = model()
+md = triangle(md,issmdir()*"/test/Exp/Square.exp", 50000.)
+md = setmask(md, "all", "")
+
+#Geometry
+hmin=300.
+hmax=1000.
+ymin=minimum(md.mesh.y)
+ymax=maximum(md.mesh.y)
+xmin=minimum(md.mesh.x)
+xmax=maximum(md.mesh.x)
+md.geometry.thickness = hmax .+ (hmin-hmax)*(md.mesh.y .- ymin)./(ymax-ymin) .+ 0.1*(hmin-hmax)*(md.mesh.x .- xmin)./(xmax-xmin)
+md.geometry.base      = -md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness
+md.geometry.surface   = md.geometry.base+md.geometry.thickness
+md.geometry.bed       = md.geometry.base .-10
+
+#Initial velocity
+x     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","x")
+y     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","y")
+vx    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vx")
+vy    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vy")
+index = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","index")
+md.initialization.vx=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y)
+md.initialization.vy=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y)
+
+md.materials.rheology_B=1.815730284801701e+08*ones(md.mesh.numberofvertices)
+md.materials.rheology_n=3*ones(md.mesh.numberofelements)
+md.friction.coefficient=20*ones(md.mesh.numberofvertices)
+
+md.stressbalance.restol=0.1
+md.stressbalance.reltol=0.02
+md.stressbalance.abstol=NaN
+
+#Boundary conditions
+nodefront=ContourToNodes(md.mesh.x,md.mesh.y,issmdir()*"/test/Exp/SquareFront.exp",2.0) .& md.mesh.vertexonboundary
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices)
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices)
+pos = findall(md.mesh.vertexonboundary .& .~nodefront)
+md.mask.ice_levelset[findall(nodefront)] .= 0
+
+segmentsfront=md.mask.ice_levelset[md.mesh.segments[:,1:2]]==0
+segments = findall(vec(sum(Int64.(md.mask.ice_levelset[md.mesh.segments[:,1:2]].==0), dims=2)) .!=2)
+pos=md.mesh.segments[segments,1:2]
+md.stressbalance.spcvx[pos] .= 0.0
+md.stressbalance.spcvy[pos] .= 0.0
+
+md=solve(md,"Stressbalance")
Index: issm/trunk/src/jl/tests/test208.jl
===================================================================
--- issm/trunk/src/jl/tests/test208.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test208.jl	(revision 26744)
@@ -0,0 +1,59 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+
+md = model()
+md = triangle(md,issmdir()*"/test/Exp/Square.exp", 150000.)
+md = setmask(md, "all", "")
+
+#Geometry
+hmin=300.
+hmax=1000.
+ymin=minimum(md.mesh.y)
+ymax=maximum(md.mesh.y)
+xmin=minimum(md.mesh.x)
+xmax=maximum(md.mesh.x)
+md.geometry.thickness = hmax .+ (hmin-hmax)*(md.mesh.y .- ymin)./(ymax-ymin) .+ 0.1*(hmin-hmax)*(md.mesh.x .- xmin)./(xmax-xmin)
+md.geometry.base      = -md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness
+md.geometry.surface   = md.geometry.base+md.geometry.thickness
+md.geometry.bed       = md.geometry.base .-10
+
+#Initial velocity
+x     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","x")
+y     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","y")
+vx    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vx")
+vy    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vy")
+index = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","index")
+md.initialization.vx=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y)
+md.initialization.vy=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y)
+
+md.materials.rheology_B=1.815730284801701e+08*ones(md.mesh.numberofvertices)
+md.materials.rheology_n=3*ones(md.mesh.numberofelements)
+md.friction.coefficient=20*ones(md.mesh.numberofvertices)
+
+md.stressbalance.restol=0.1
+md.stressbalance.reltol=0.02
+md.stressbalance.abstol=NaN
+md.timestepping.start_time = 0.0
+md.timestepping.final_time = 3.0
+md.timestepping.time_step  = 1.0
+
+#Boundary conditions
+nodefront=ContourToNodes(md.mesh.x,md.mesh.y,issmdir()*"/test/Exp/SquareFront.exp",2.0) .& md.mesh.vertexonboundary
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices)
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices)
+pos = findall(md.mesh.vertexonboundary .& .~nodefront)
+md.mask.ice_levelset[findall(nodefront)] .= 0
+
+segmentsfront=md.mask.ice_levelset[md.mesh.segments[:,1:2]]==0
+segments = findall(vec(sum(Int64.(md.mask.ice_levelset[md.mesh.segments[:,1:2]].==0), dims=2)) .!=2)
+pos=md.mesh.segments[segments,1:2]
+md.stressbalance.spcvx[pos] .= 0.0
+md.stressbalance.spcvy[pos] .= 0.0
+
+md.smb.mass_balance = zeros(md.mesh.numberofvertices)
+md.basalforcings.groundedice_melting_rate = zeros(md.mesh.numberofvertices)
+md.basalforcings.floatingice_melting_rate = ones(md.mesh.numberofvertices)
+md.masstransport.spcthickness = NaN*ones(md.mesh.numberofvertices)
+
+md=solve(md,"Transient")
Index: issm/trunk/src/jl/tests/test301.jl
===================================================================
--- issm/trunk/src/jl/tests/test301.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test301.jl	(revision 26744)
@@ -0,0 +1,45 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+
+md = model()
+md = triangle(md,issmdir()*"/test/Exp/Square.exp",150000.)
+md = setmask(md,"","")
+
+#Geometry
+hmin=300.
+hmax=1000.
+ymin=minimum(md.mesh.y)
+ymax=maximum(md.mesh.y)
+xmin=minimum(md.mesh.x)
+xmax=maximum(md.mesh.x)
+md.geometry.thickness = hmax .+ (hmin-hmax)*(md.mesh.y .- ymin)./(ymax-ymin) .+ 0.1*(hmin-hmax)*(md.mesh.x .- xmin)./(xmax-xmin)
+md.geometry.base      = -md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness .+20
+md.geometry.surface   = md.geometry.base+md.geometry.thickness
+md.geometry.bed       = md.geometry.base
+
+#Initial velocity
+#x     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","x")
+#y     = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","y")
+#vx    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vx")
+#vy    = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","vy")
+#index = archread(issmdir()*"/test/Data/SquareShelfConstrained.arch","index")
+md.initialization.vx=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y)
+md.initialization.vy=zeros(md.mesh.numberofvertices)#InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y)
+
+md.materials.rheology_B=1.815730284801701e+08*ones(md.mesh.numberofvertices)
+md.materials.rheology_n=3*ones(md.mesh.numberofelements)
+md.friction.coefficient=20*ones(md.mesh.numberofvertices)
+
+md.stressbalance.restol=0.05
+md.stressbalance.reltol=0.05
+md.stressbalance.abstol=NaN
+
+#Boundary conditions
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices)
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices)
+pos = findall(md.mesh.vertexonboundary)
+md.stressbalance.spcvx[pos] .= 0.0
+md.stressbalance.spcvy[pos] .= 0.0
+
+md=solve(md,"Stressbalance")
Index: issm/trunk/src/jl/tests/test501.jl
===================================================================
--- issm/trunk/src/jl/tests/test501.jl	(revision 26744)
+++ issm/trunk/src/jl/tests/test501.jl	(revision 26744)
@@ -0,0 +1,50 @@
+#!/Applications/Julia-1.6.app/Contents/Resources/julia/bin/julia
+include("../issm.jl")
+using .ISSM
+
+md = model()
+md = triangle(md,issmdir()*"/test/Exp/Pig.exp",10000.)
+md = setmask( md,issmdir()*"/test/Exp/PigShelves.exp",issmdir()*"/test/Exp/PigIslands.exp")
+
+#Initial velocity and geometry
+x         = archread(issmdir()*"/test/Data/Pig.arch","x")
+y         = archread(issmdir()*"/test/Data/Pig.arch","y")
+vx_obs    = archread(issmdir()*"/test/Data/Pig.arch","vx_obs")
+vy_obs    = archread(issmdir()*"/test/Data/Pig.arch","vy_obs")
+index     = Int.(archread(issmdir()*"/test/Data/Pig.arch","index"))
+surface   = archread(issmdir()*"/test/Data/Pig.arch","surface")
+thickness = archread(issmdir()*"/test/Data/Pig.arch","thickness")
+bed       = archread(issmdir()*"/test/Data/Pig.arch","bed")
+md.initialization.vx=InterpFromMeshToMesh2d(index, x, y, vx_obs, md.mesh.x, md.mesh.y, 0.0)
+md.initialization.vy=InterpFromMeshToMesh2d(index, x, y, vy_obs, md.mesh.x, md.mesh.y, 0.0)
+md.geometry.surface = InterpFromMeshToMesh2d(index, x, y, surface, md.mesh.x, md.mesh.y, 0.0)
+md.geometry.thickness = InterpFromMeshToMesh2d(index, x, y, thickness, md.mesh.x, md.mesh.y, 0.0)
+md.geometry.base=md.geometry.surface .- md.geometry.thickness
+md.geometry.bed =md.geometry.base
+pos = findall(md.mask.ocean_levelset.<0)
+md.geometry.bed[pos] = InterpFromMeshToMesh2d(index, x, y, bed, md.mesh.x[pos], md.mesh.y[pos])
+
+md.materials.rheology_B=1.815730284801701e+08*ones(md.mesh.numberofvertices)
+md.materials.rheology_n=3*ones(md.mesh.numberofelements)
+md.friction.coefficient=50*ones(md.mesh.numberofvertices)
+
+md.stressbalance.restol=0.05
+md.stressbalance.reltol=1.0
+md.stressbalance.abstol=NaN
+
+#Boundary conditions
+pos = findall(vec(sum(Int64.(md.mask.ocean_levelset[md.mesh.elements].<0), dims=2)) .> 0.0)
+vertexonfloatingice=zeros(md.mesh.numberofvertices)
+vertexonfloatingice[md.mesh.elements[pos,:]] .= 1
+nodefront=(md.mesh.vertexonboundary .& (vertexonfloatingice.>0))
+md.mask.ice_levelset[findall(nodefront)] .= 0
+
+md.stressbalance.spcvx = NaN*ones(md.mesh.numberofvertices)
+md.stressbalance.spcvy = NaN*ones(md.mesh.numberofvertices)
+segmentsfront=md.mask.ice_levelset[md.mesh.segments[:,1:2]]==0
+segments = findall(vec(sum(Int64.(md.mask.ice_levelset[md.mesh.segments[:,1:2]].==0), dims=2)) .!=2)
+pos=md.mesh.segments[segments,1:2]
+md.stressbalance.spcvx[pos] .= 0.0
+md.stressbalance.spcvy[pos] .= 0.0
+
+md=solve(md,"Stressbalance")
